"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
/**
 *
 */
function enums(items, options) {
    if (options === void 0) { options = {
        required: true,
    }; }
    var required = options.required !== undefined ? options.required : true;
    var nullable = options.nullable !== undefined ? options.nullable : false;
    // const defaultv = options.default !== undefined ? options.default : undefined
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        var wrap = utils_1.wrapSchema(target);
        if (nullable) {
            wrap.properties[name] = {
                anyOf: [
                    {
                        type: 'string',
                        enum: items,
                        default: options.default,
                    },
                    {
                        type: 'null',
                    },
                ],
            };
        }
        else {
            wrap.properties[name] = {
                type: 'string',
                enum: items,
                default: options.default,
            };
        }
        if (required) {
            var r = wrap.required;
            if (!r.includes(name)) {
                r.push(name);
            }
        }
    };
}
exports.default = enums;
//# sourceMappingURL=enums.js.map