"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
// function prop(prop?: {
// 	required?: boolean
// 	schema?: JsonSchema4String | JsonSchema4Numeric | JsonSchema4Boolean
// }): any
/**
 *
 */
function prop() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var required = true;
    var nullable = false;
    var schema = undefined;
    if (args === null || args === void 0 ? void 0 : args.length) {
        var type = typeof args[0] === 'function' ? args[0] : undefined;
        if (typeof args[0] !== 'function' && typeof args[0] === 'object') {
            required = 'required' in args[0] ? args[0].required : required;
            nullable = 'nullable' in args[0] ? args[0].nullable : nullable;
            schema = 'schema' in args[0] ? args[0].schema : schema;
        }
        else if (args[1] !== undefined && typeof args[1] === 'object') {
            required = 'required' in args[1] ? args[1].required : required;
            nullable = 'nullable' in args[1] ? args[1].nullable : nullable;
            schema = 'schema' in args[1] ? args[1].schema : schema;
        }
    }
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        var wrap = utils_1.wrapSchema(target);
        var meta = utils_1.getMetadata(target, name);
        if (meta.name === 'Array' && type === undefined) {
            throw new TypeError("in " + target.constructor.name + "::" + name + " unable to recognize type array. use example: @prop(String, schemaItemProps)");
        }
        if (nullable) {
            wrap.properties[name] = {
                anyOf: [
                    utils_1.buildProperty(type !== undefined ? type.name : meta.name, schema),
                    { type: 'null' },
                ],
            };
        }
        else {
            // add current prop
            wrap.properties[name] = utils_1.buildProperty(type !== undefined ? type.name : meta.name, schema);
        }
        if (required) {
            var r = wrap.required;
            if (r.includes(name) === false) {
                r.push(name);
            }
        }
    };
}
exports.default = prop;
//# sourceMappingURL=prop.js.map