"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var use_1 = require("../use");
/**
 *
 */
function ref(type, _a) {
    var _b = _a === void 0 ? {
        required: true,
        nullable: false,
    } : _a, required = _b.required, nullable = _b.nullable;
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        var wrap = utils_1.wrapSchema(target);
        // const meta = getMetadata(target, name)
        required = required !== undefined ? required : true;
        nullable = nullable !== undefined ? nullable : false;
        if (nullable) {
            wrap.properties[name] = {
                anyOf: [use_1.use(type), { type: 'null' }],
            };
        }
        else {
            // add current prop
            wrap.properties[name] = use_1.use(type);
        }
        if (required) {
            var r = wrap.required;
            r.push(name);
        }
    };
}
exports.default = ref;
//# sourceMappingURL=ref.js.map