"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useArray = exports.use = void 0;
function use(constructor) {
    var ctoschema = constructor;
    if (ctoschema === undefined) {
        throw new Error("undefined schema for " + constructor);
    }
    if ('__schema' in ctoschema === false) {
        throw new TypeError(ctoschema.name + ": not a schema class");
    }
    return JSON.parse(JSON.stringify(ctoschema.__schema));
}
exports.use = use;
function useArray(constructor) {
    var ctoschema = constructor;
    if ('__schema' in ctoschema === false) {
        throw new TypeError(constructor + ": not a schema class");
    }
    return {
        type: 'array',
        items: JSON.parse(JSON.stringify(ctoschema.__schema)),
    };
}
exports.useArray = useArray;
//# sourceMappingURL=use.js.map